<html>
<head>
<title>RManNotes: Regular Patterns: Shapes</title>
</head>

<body bgcolor="#f9f9b1" background="notepad.gif" link="801010" vlink="101080" alink="108010"> <img alt="RManNotes" align=center src="header.gif">

<img align=center hspace=10 src="reg_patterns.gif">

<p><img src="black_line.gif"></p>
<p>
<a href="txtr_coords.html">previous</a>
|
<i>next</i>
|
<a href="index.html">regular patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>
<p><img src="black_line.gif"></p>

<h1><a name="top">Shape Generation</a></h1>

<p>
Simple, geometric shapes can be made in the RenderMan Shading Language 
using 
<a href="Transitions.html#smoothstep"><code>smoothstep</code></a>
or 
<a href="Transitions.html#pulses"><code>pulse</code></a>
often with one of two shading language <i>distance</i> functions:
<ul>
<li><b><i>distance</i></b> -- computes the distance between two points... good
for drawing <a href="#disks_circles">disks and rings</a>.
<li><b><i>ptlined</i></b> -- computes the <i>shortest</i> distance between 
a point and a line... good for drawing <a href="#lines">lines</a> or polygons.
<small><i>Note: ptlined is not defined in the RenderMan Shading 
Langauge spec, but is supported by both renderers.</i></small>
</ul>
</p>

<p>
Further, simple geometric shapes can be combined to generate
more complex shapes using <a href="#bool">boolean set operations</a>
(union, intersection, difference, and complement).
</p>

<table border=3 cellpadding=5 width=100%>
<tr><td>
<p align=right><small>RenderMan Shading Language function</small></p>
<p>
<b>float distance(point p1, p2)</b><br>
<b>float ptlined(point a, b, p)</b>
</p>
<p align=center>
<img src="distance.gif"><br>
<small>Graphic interpretation of (a) <code>d = distance(p1,p2)</code>; and (b)
<code>d = ptlined(a,b,p)</code>.</small>
</p>
</table>

<h2><a name="rectangles">Rectangles</a></h2>

<p>
Rectangular shapes can be made by intersecting (multiplying) a
vertical 
<a href="Transitions.html#pulses">pulse</a> and a horizontal 
pulse. (In fact you can
use <a href="#bool"><code>intersection</code></a> instead of the
multiplication operator.)
</p>

<p align=center>
<img src="rect.gif"><br>
<a href="rect.sl">rect.sl</a>
</p>

<h2><a name="disks_circles">Disks and Rings</a></h2>

<p>
Disks and rings can be generated using 
<a href="#top"><code>distance</code></a> and
either <a href="transitions.html#smoothstep"><code>smoothstep</code></a> 
(for a disk) or <a href="transitions.html#pulses"><code>pulse</code></a>
(for a ring). The idea for disks is simple: if the distance between the
current shading point and the center of the disk is less than the radius
of the disk, then the current shading point is inside the disk. In terms of
a pulse, we have:
</p>

<p align=center>
<img src="disk_pulse.gif">
</p>

<p>
where <i>d</i> is the distance between the current shading point and
the center of the disk. Note that this pulse is generated by 
<i>1 - smoothstep(radius - fuzz, radius, d)</i>. 
The corresponding shader is shown below.
</p>

<p align=center>
<img src="disk.gif"><br>
<a href="disk.sl">disk.sl</a>
</p>

<p>
The idea for rings is identical, except that a pulse is used instead of
smoothstep.
</p>

<p align=center>
<img src="ring.gif"><br>
<a href="ring.sl">ring.sl</a>
</p>

<h2><a name="lines">Lines</a></h2>

<p>
Lines are generated like disks except that the distance is computed
from the current shading point to the nearest point on the line using
<a href="#top"><code>ptlined</code></a>.

<p align=center>
<img src="line.gif"><br>
<a href="line.sl">line.sl</a>
</p>

<h2><a name="bool">Boolean Operations</a></h2>

<p>
Constructive solid geometry (CSG) is used in solid modeling systems to create complex shapes from the 
union, intersection, or difference of 2 simpler shapes. These are referred to as "boolean" operations since 
they operate on only 2 shapes at a time (with the exception of "complement"). While CSG is difficult to do with 3D b-reps, it's trivial to do with procedural shapes in shaders.
</p>
<p align=center>
<img src="moon.gif"><br>
<a href="moon.sl">moon.sl</a>
</p>

<table border=3 cellpadding=5 width=100%>
<tr><td>
<p align=right><small>RManNotes function</small></p>
<p>
<b>float union(float a, b)</b><br>
<b>float difference(float a, b)</b><br>
<b>float intersection(float a, b)</b><br>
<b>float complement(float a, b)</b>
</p>
<p><i>
Boolean operations. Each returns a value between 0 and 1 and requires
inputs between 0 and 1.
The implementations are from <a href="../references.html">[Perlin89]</a>.
</i></p>
</table>

<p>
Below are illustrations of the various boolean operations based on 
disk and square shapes.
</p>

<center>
<table>
</table>
</center>

<center>
<table>
<tr><td><img src="bool_1.gif"><td><small>disk = D</small>
<td><img src="bool_2.gif"><td><small>square = S</small>
<tr><td><img src="bool_3.gif"><td><small>union(D,S)</small>
<td><img src="bool_6.gif"><td><small>intersection(D,S)</small>
<tr><td><img src="bool_4.gif"><td><small>difference(D,S)</small>
<td><img src="bool_5.gif"><td><small>difference(S,D)</small>
<tr><td><img src="bool_7.gif"><td><small>complement(difference(D,S))</small>
<td><img src="bool_8.gif"><td><small>union(difference(S,D), difference(D,S))</small>
</table>
</center>

<p>
Finally, the disk_ring shader illustrates a masking effect between different
shapes repeated at different scales.
</p>

<p align=center>
<img src="bool_9.gif"><br>
<a href="diskring.sl">diskring.sl</a>
</p>

<p><img src="black_line.gif"></p>
<p>
<a href="txtr_coords.html">previous</a>
|
<i>next</i>
|
<a href="index.html">regular patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>

<p><img src="black_line.gif"></p> <small> <p><i>RManNotes</i> is Copyright &copy; 1995, 1996 Stephen F. May</p> <p> <i>Any comments or suggestions appreciated.</i> <address><a href="http://www.cgrg.ohio-state.edu/~smay">Steve May</a> (<a href="mailto:smay@cgrg.ohio-state.edu">smay@cgrg.ohio-state.edu</a>)</address> </p> </small>

<p align=right><small><i>Last Modified: 4/15/96</i></small></p>

</body>
</html>
